diff -Naur test-for-latech/include/net/route.h testqf-for-latech/include/net/route.h
--- test-for-latech/include/net/route.h	2004-06-11 07:40:22.000000000 -0400
+++ testqf-for-latech/include/net/route.h	2004-06-11 07:47:33.000000000 -0400
@@ -1,188 +1,145 @@
-/*
- * INET		An implementation of the TCP/IP protocol suite for the LINUX
- *		operating system.  INET  is implemented using the  BSD Socket
- *		interface as the means of communication with the user level.
- *
- *		Definitions for the IP router.
- *
- * Version:	@(#)route.h	1.0.4	05/27/93
- *
- * Authors:	Ross Biro, <bir7@leland.Stanford.Edu>
- *		Fred N. van Kempen, <waltje@uWalt.NL.Mugnet.ORG>
- * Fixes:
- *		Alan Cox	:	Reformatted. Added ip_rt_local()
- *		Alan Cox	:	Support for TCP parameters.
- *		Alexey Kuznetsov:	Major changes for new routing code.
- *		Mike McLagan    :	Routing by source
- *		Robert Olsson   :	Added rt_cache statistics
- *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- */
-#ifndef _ROUTE_H
-#define _ROUTE_H
-
-#include <linux/config.h>
-#include <net/dst.h>
-#include <net/inetpeer.h>
-#include <linux/in_route.h>
-#include <linux/rtnetlink.h>
-#include <linux/route.h>
-#include <linux/ip.h>
-#include <linux/cache.h>
+/* Copyright (C) 1997, 2002 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
 
-#ifndef __KERNEL__
-#warning This file is not supposed to be used outside of kernel.
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, write to the Free
+   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
+   02111-1307 USA.  */
+
+/* Based on the 4.4BSD and Linux version of this file.  */
+
+#ifndef _NET_ROUTE_H
+#define _NET_ROUTE_H	1
+
+#include <features.h>
+#include <sys/socket.h>
+#include <sys/types.h>
+#include <netinet/in.h>
+#include <bits/wordsize.h>
+
+
+/* This structure gets passed by the SIOCADDRT and SIOCDELRT calls. */
+struct rtentry
+  {
+    unsigned long int rt_pad1;
+    struct sockaddr rt_dst;		/* Target address.  */
+    struct sockaddr rt_gateway;		/* Gateway addr (RTF_GATEWAY).  */
+    struct sockaddr rt_genmask;		/* Target network mask (IP).  */
+    unsigned short int rt_flags;
+    short int rt_pad2;
+    unsigned long int rt_pad3;
+    unsigned char rt_tos;
+    unsigned char rt_class;
+#if __WORDSIZE == 64
+    short int rt_pad4[3];
+#else
+    short int rt_pad4;
 #endif
+    short int rt_metric;		/* +1 for binary compatibility!  */
+    char *rt_dev;			/* Forcing the device at add.  */
+    unsigned long int rt_mtu;		/* Per route MTU/Window.  */
+    unsigned long int rt_window;	/* Window clamping.  */
+    unsigned short int rt_irtt;		/* Initial RTT.  */
+  };
+/* Compatibility hack.  */
+#define rt_mss	rt_mtu
+
+
+struct in6_rtmsg
+  {
+    struct in6_addr rtmsg_dst;
+    struct in6_addr rtmsg_src;
+    struct in6_addr rtmsg_gateway;
+    u_int32_t rtmsg_type;
+    u_int16_t rtmsg_dst_len;
+    u_int16_t rtmsg_src_len;
+    u_int32_t rtmsg_metric;
+    unsigned long int rtmsg_info;
+    u_int32_t rtmsg_flags;
+    int rtmsg_ifindex;
+  };
+
+
+#define	RTF_UP		0x0001		/* Route usable.  */
+#define	RTF_GATEWAY	0x0002		/* Destination is a gateway.  */
+
+#define	RTF_HOST	0x0004		/* Host entry (net otherwise).  */
+#define RTF_REINSTATE	0x0008		/* Reinstate route after timeout.  */
+#define	RTF_DYNAMIC	0x0010		/* Created dyn. (by redirect).  */
+#define	RTF_MODIFIED	0x0020		/* Modified dyn. (by redirect).  */
+#define RTF_MTU		0x0040		/* Specific MTU for this route.  */
+#define RTF_MSS		RTF_MTU		/* Compatibility.  */
+#define RTF_WINDOW	0x0080		/* Per route window clamping.  */
+#define RTF_IRTT	0x0100		/* Initial round trip time.  */
+#define RTF_REJECT	0x0200		/* Reject route.  */
+#define	RTF_STATIC	0x0400		/* Manually injected route.  */
+#define	RTF_XRESOLVE	0x0800		/* External resolver.  */
+#define RTF_NOFORWARD   0x1000		/* Forwarding inhibited.  */
+#define RTF_THROW	0x2000		/* Go to next class.  */
+#define RTF_NOPMTUDISC  0x4000		/* Do not send packets with DF.  */
+
+/* for IPv6 */
+#define RTF_DEFAULT	0x00010000	/* default - learned via ND	*/
+#define RTF_ALLONLINK	0x00020000	/* fallback, no routers on link	*/
+#define RTF_ADDRCONF	0x00040000	/* addrconf route - RA		*/
+
+#define RTF_LINKRT	0x00100000	/* link specific - device match	*/
+#define RTF_NONEXTHOP	0x00200000	/* route with no nexthop	*/
+
+#define RTF_CACHE	0x01000000	/* cache entry			*/
+#define RTF_FLOW	0x02000000	/* flow significant route	*/
+#define RTF_POLICY	0x04000000	/* policy route			*/
+
+#define RTCF_VALVE	0x00200000
+#define RTCF_MASQ	0x00400000
+#define RTCF_NAT	0x00800000
+#define RTCF_DOREDIRECT 0x01000000
+#define RTCF_LOG	0x02000000
+#define RTCF_DIRECTSRC	0x04000000
+
+#define RTF_LOCAL	0x80000000
+#define RTF_INTERFACE	0x40000000
+#define RTF_MULTICAST	0x20000000
+#define RTF_BROADCAST	0x10000000
+#define RTF_NAT		0x08000000
+
+#define RTF_ADDRCLASSMASK	0xF8000000
+#define RT_ADDRCLASS(flags)	((__u_int32_t) flags >> 23)
+
+#define RT_TOS(tos)		((tos) & IPTOS_TOS_MASK)
+
+#define RT_LOCALADDR(flags)	((flags & RTF_ADDRCLASSMASK) \
+				 == (RTF_LOCAL|RTF_INTERFACE))
+
+#define RT_CLASS_UNSPEC		0
+#define RT_CLASS_DEFAULT	253
+
+#define RT_CLASS_MAIN		254
+#define RT_CLASS_LOCAL		255
+#define RT_CLASS_MAX		255
+
+
+#define RTMSG_ACK		NLMSG_ACK
+#define RTMSG_OVERRUN		NLMSG_OVERRUN
+
+#define RTMSG_NEWDEVICE		0x11
+#define RTMSG_DELDEVICE		0x12
+#define RTMSG_NEWROUTE		0x21
+#define RTMSG_DELROUTE		0x22
+#define RTMSG_NEWRULE		0x31
+#define RTMSG_DELRULE		0x32
+#define RTMSG_CONTROL		0x40
 
-#define RTO_ONLINK	0x01
+#define RTMSG_AR_FAILED		0x51	/* Address Resolution failed.  */
 
-#define RTO_CONN	0
-/* RTO_CONN is not used (being alias for 0), but preserved not to break
- * some modules referring to it. */
-
-#define RT_CONN_FLAGS(sk)   (RT_TOS(sk->protinfo.af_inet.tos) | sk->localroute)
-
-struct rt_key
-{
-	__u32			dst;
-	__u32			src;
-	int			iif;
-	int			oif;
-#ifdef CONFIG_IP_ROUTE_FWMARK
-	__u32			fwmark;
-#endif
-	__u8			tos;
-	__u8			scope;
-};
-
-struct inet_peer;
-struct rtable
-{
-	union
-	{
-		struct dst_entry	dst;
-		struct rtable		*rt_next;
-	} u;
-
-	unsigned		rt_flags;
-	unsigned		rt_type;
-
-	__u32			rt_dst;	/* Path destination	*/
-	__u32			rt_src;	/* Path source		*/
-	int			rt_iif;
-
-	/* Info on neighbour */
-	__u32			rt_gateway;
-
-	/* Cache lookup keys */
-	struct rt_key		key;
-
-	/* Miscellaneous cached information */
-	__u32			rt_spec_dst; /* RFC1122 specific destination */
-	struct inet_peer	*peer; /* long-living peer info */
-
-#ifdef CONFIG_IP_ROUTE_NAT
-	__u32			rt_src_map;
-	__u32			rt_dst_map;
-#endif
-};
-
-struct ip_rt_acct
-{
-	__u32 	o_bytes;
-	__u32 	o_packets;
-	__u32 	i_bytes;
-	__u32 	i_packets;
-};
-
-struct rt_cache_stat 
-{
-        unsigned int in_hit;
-        unsigned int in_slow_tot;
-        unsigned int in_slow_mc;
-        unsigned int in_no_route;
-        unsigned int in_brd;
-        unsigned int in_martian_dst;
-        unsigned int in_martian_src;
-        unsigned int out_hit;
-        unsigned int out_slow_tot;
-        unsigned int out_slow_mc;
-        unsigned int gc_total;
-        unsigned int gc_ignored;
-        unsigned int gc_goal_miss;
-        unsigned int gc_dst_overflow;
-} ____cacheline_aligned_in_smp;
-
-extern struct ip_rt_acct *ip_rt_acct;
-
-struct in_device;
-extern void		ip_rt_init(void);
-extern void		ip_rt_redirect(u32 old_gw, u32 dst, u32 new_gw,
-				       u32 src, u8 tos, struct net_device *dev);
-extern void		ip_rt_advice(struct rtable **rp, int advice);
-extern void		rt_cache_flush(int how);
-extern int		ip_route_output_key(struct rtable **, const struct rt_key *key);
-extern int		ip_route_input(struct sk_buff*, u32 dst, u32 src, u8 tos, struct net_device *devin);
-extern unsigned short	ip_rt_frag_needed(struct iphdr *iph, unsigned short new_mtu);
-extern void		ip_rt_update_pmtu(struct dst_entry *dst, unsigned mtu);
-extern void		ip_rt_send_redirect(struct sk_buff *skb);
-
-extern unsigned		inet_addr_type(u32 addr);
-extern void		ip_rt_multicast_event(struct in_device *);
-extern int		ip_rt_ioctl(unsigned int cmd, void *arg);
-extern void		ip_rt_get_source(u8 *src, struct rtable *rt);
-extern int		ip_rt_dump(struct sk_buff *skb,  struct netlink_callback *cb);
-
-/* Deprecated: use ip_route_output_key directly */
-static inline int ip_route_output(struct rtable **rp,
-				      u32 daddr, u32 saddr, u32 tos, int oif)
-{
-	struct rt_key key = { dst:daddr, src:saddr, oif:oif, tos:tos };
-
-	return ip_route_output_key(rp, &key);
-}
-
-
-static inline void ip_rt_put(struct rtable * rt)
-{
-	if (rt)
-		dst_release(&rt->u.dst);
-}
-
-#define IPTOS_RT_MASK	(IPTOS_TOS_MASK & ~3)
-
-extern __u8 ip_tos2prio[16];
-
-static inline char rt_tos2priority(u8 tos)
-{
-	return ip_tos2prio[IPTOS_TOS(tos)>>1];
-}
-
-static inline int ip_route_connect(struct rtable **rp, u32 dst, u32 src, u32 tos, int oif)
-{
-	int err;
-	err = ip_route_output(rp, dst, src, tos, oif);
-	if (err || (dst && src))
-		return err;
-	dst = (*rp)->rt_dst;
-	src = (*rp)->rt_src;
-	ip_rt_put(*rp);
-	*rp = NULL;
-	return ip_route_output(rp, dst, src, tos, oif);
-}
-
-extern void rt_bind_peer(struct rtable *rt, int create);
-
-static inline struct inet_peer *rt_get_peer(struct rtable *rt)
-{
-	if (rt->peer)
-		return rt->peer;
-
-	rt_bind_peer(rt, 0);
-	return rt->peer;
-}
-
-#endif	/* _ROUTE_H */
+#endif /* net/route.h */
diff -Naur test-for-latech/include/net/sock.h testqf-for-latech/include/net/sock.h
--- test-for-latech/include/net/sock.h	2004-06-11 07:40:22.000000000 -0400
+++ testqf-for-latech/include/net/sock.h	2004-06-11 07:47:33.000000000 -0400
@@ -678,6 +678,21 @@
   	int			(*backlog_rcv) (struct sock *sk,
 						struct sk_buff *skb);  
 	void                    (*destruct)(struct sock *sk);
+
+	int 			drop_flag;
+	int			urgent_flag;
+	int			fragments;
+#ifdef CONFIG_QFABRIC
+	int 			owner;
+	int 			kecho;
+	void  			*kecho_ptr;
+	short			readable;
+	short			writable;
+	int			fd;
+	int 			counter;
+	long			qos_priority;
+	long			qos_deadline;
+#endif
 };
 
 /* The per-socket spinlock must be held here. */
diff -Naur test-for-latech/include/net/tcp.h testqf-for-latech/include/net/tcp.h
--- test-for-latech/include/net/tcp.h	2004-06-11 07:40:22.000000000 -0400
+++ testqf-for-latech/include/net/tcp.h	2004-06-11 07:47:33.000000000 -0400
@@ -520,6 +520,10 @@
 		struct tcp_v6_open_req v6_req;
 #endif
 	} af;
+#ifdef CONFIG_QFABRIC
+	int	priority;
+	long	deadline_msec;
+#endif
 };
 
 /* SLAB cache for open requests. */
@@ -1590,6 +1594,94 @@
 	req->dl_next = NULL;
 }
 
+#ifdef CONFIG_QFABRIC
+static inline struct sock *tcp_acceptq_queue_prio(struct sock *sk, 
+		struct open_request *req, struct sock *child, int drop)
+{
+	struct tcp_opt *tp = &sk->tp_pinfo.af_tcp;
+	struct open_request *ptr, *prev;
+	struct sock *tmp;
+
+	req->sk = child;
+	sk->qos_priority = req->priority;
+	sk->qos_deadline = req->deadline_msec;
+	child->qos_priority = req->priority;
+	child->qos_deadline = req->deadline_msec;
+
+	if (!tp->accept_queue_tail) {
+		tp->accept_queue = req;
+		tp->accept_queue_tail = req;
+		req->dl_next = NULL;
+	} else {
+		ptr = tp->accept_queue;
+		prev = ptr;
+		if (req->priority >= 0) {
+			while ((ptr != NULL)&&(ptr->priority >= req->priority)) 
+			{
+				prev = ptr;
+				ptr = ptr->dl_next;
+			}
+			if (ptr == NULL) {
+				if ((drop == 1) && (!tcp_acceptq_is_full(sk))) {
+				    tp->accept_queue_tail = req;
+				    req->dl_next = NULL;
+				} else	{
+					tcp_openreq_free(req);
+					return child;
+				}
+			} else {
+				req->dl_next = ptr;
+				prev->dl_next = req;
+				if ((drop == 1) && (tcp_acceptq_is_full(sk))) {
+			            while (ptr != NULL) {
+					ptr = ptr->dl_next;
+					if (ptr != NULL) prev = prev->dl_next;
+				    }
+				    tmp = prev->dl_next->sk;
+				    tcp_openreq_free(prev->dl_next);
+				    prev->dl_next = NULL;
+				    return tmp;
+				}
+			}
+		} else if (req->deadline_msec != -1) {
+			while ((ptr != NULL) && 
+				(ptr->deadline_msec <= req->deadline_msec)) {
+				prev = ptr;
+				ptr = ptr->dl_next;
+			}
+			if (ptr == NULL) {
+				if ((drop == 1) && (!tcp_acceptq_is_full(sk))) {
+					tp->accept_queue_tail = req;
+					req->dl_next = NULL;
+				} else	{
+					tcp_openreq_free(req);
+					return child;
+				}
+			} else {
+				req->dl_next = ptr;
+				prev->dl_next = req;
+				if ((drop == 1) && (tcp_acceptq_is_full(sk))) {
+			            while (ptr != NULL) {
+					ptr = ptr->dl_next;
+					if (ptr != NULL) prev = prev->dl_next;
+				    }
+				    tmp = prev->dl_next->sk;
+				    tcp_openreq_free(prev->dl_next);
+				    prev->dl_next = NULL;
+				    return tmp;
+				}
+			}
+		} else {
+			tp->accept_queue_tail->dl_next = req;
+			tp->accept_queue_tail = req;
+			req->dl_next = NULL;
+		}
+	}
+	tcp_acceptq_added(sk);
+	return NULL;
+}
+#endif
+
 struct tcp_listen_opt
 {
 	u8			max_qlen_log;	/* log_2 of maximal queued SYNs */
@@ -1665,6 +1757,10 @@
 	req->acked = 0;
 	req->ecn_ok = 0;
 	req->rmt_port = skb->h.th->source;
+#ifdef CONFIG_QFABRIC
+	req->priority = -1;
+	req->deadline_msec = -1;
+#endif 
 }
 
 #define TCP_MEM_QUANTUM	((int)PAGE_SIZE)
diff -Naur test-for-latech/include/net/utils.h testqf-for-latech/include/net/utils.h
--- test-for-latech/include/net/utils.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/net/utils.h	2004-06-11 07:47:33.000000000 -0400
@@ -0,0 +1,19 @@
+static __inline__ int socket_hash(u32 handle)
+{
+  return handle&0xFF;
+}
+
+
+static __inline__ struct socket *socki_lookup(struct inode *inode)
+{
+	return &inode->u.socket_i;
+}
+
+static __inline__ unsigned dwcs_hash(u32 h)
+{
+    h ^= h>>8;
+    h ^= h>>4;
+    return h&0xF;
+}
+
+
